

// Enhanced CString class

// Cribbed from Paul DiLascia, MSJ Nov. 1993 
// WL 29/12/95

#include "stdafx.h"
#include "enhstr.h"
#include <stdio.h>
#include <stdarg.h>

// printf into string object

int CEnhString::printf(CSTR fmt, ...)
{
	char buf[1024];
	va_list args;
	va_start(args, fmt);
	int ret = vsprintf(buf, fmt, args);
	*this += buf;
	va_end(args);
	return ret;
}


// Strip ANSI formatting characters from string

void CEnhString::StripAnsi()
{
	int i=0;

	char *start = GetBuffer(1);
	char *end;

	while((start = strstr(start, "\x1b[")) != NULL)
	{
		end = start + 2;
		
		while(*end)
		{
			if(!((*end >= '0' && *end <= '9') || *end == ';'))
				break;

			end++;
		}

		if(!(*end))
			return;			// run out of string

		if(*end == 'm')
		{
			// found a valid ansi colour sequence

			end++;

			memmove(start, end, strlen(end) + 1);
		}
		else
			start = end;
	}

	ReleaseBuffer(-1);
}

void CEnhString::Replace(LPCTSTR targ, LPCTSTR repl)
{
  CString csNew, csOld;
  int s;
  LPSTR p;

  csOld = GetBuffer(1);

  while((s = csOld.Find(targ)) >= 0)
  {
    csNew += Left(s);
    csOld = csOld.Right(GetLength()-s);
  }

  csNew += csOld;
  p = GetBuffer(csNew.GetLength() + 1);
  strcpy(p, csNew);
  ReleaseBuffer(-1);  
}

