/*
 * Screen buffer class definition file
 * 
 * WL 28/11/94
 */


class CScreenBuffer
{
public:
		CScreenBuffer();
		CScreenBuffer(int iSize);
		~CScreenBuffer();

		CString *GetCurrent(void);
		long GetCurrentLine(void);
		BOOL SetCurrentLine(int iType, long lOffset);
		long Range(void);
		BOOL AddLine(const char *pcBuf);
		BOOL ReplaceCurrent(char *pcBuf);
		int  GetInsertPos(void);
		BOOL SetInsertPos(int iType, int lOffset);
		BOOL InsertChar(char c);
		long GetInsertLine(void);
		void SetMaxLines(unsigned iMax);
		BOOL InsertAnsi(const char *pcBuf);

private:
		BOOL DisposeLines();
		CString *GetLineBuffer(const char *pcBuf);
		BOOL FreeLineBuffer(CString *pCS);
/*	 	void ParseAnsi(char *str, struct colorstate *csPrev, struct colorstate *csNext);
		void GetColorsForLine(int, struct colorstate *cs);
		void GetPreviousStringForLine(int line, char *buf);
		void MakeColorString(struct colorstate *cs, char *buf);
*/
		CString **LineBuffer;			// Array of buffers holding individual lines to paint to the screen
		unsigned long LastLine;			// Highest valid index into LineBuffer
		unsigned long MaxLines;			// Highest possible index into LineBuffer
		unsigned long Current;			// Line index (index into LineBuffer) of line currently being retrieved
		unsigned long InsertLine;		// Line index (index into LineBuffer) of current insertion point
		unsigned InsertPos;				// Column index of current insertion point
		unsigned InsertMode;			// 0 means overwrite, <>0 means insert
};


// Types for SetCurrent

#define SBSTART 	0
#define SBEND   	1
#define SBCURR  	2


// Default number of lines in buffer. 

#define	DEFAULT_BUFFER_SIZE	200000

