// telnedoc.cpp : implementation of the CTelnetDoc class
//

#include "stdafx.h"
#include "afxctl.h"

#include "scrbuf.h"
#include "telnedoc.h"
#include "telnet.h"
#include "telnevw.h"
#include "mainfrm.h"
#include <winsock.h>
#include "enhstr.h"
#include "connectdialog.h"
#include "mapper.h"
#include "winsink.h"
// #import "Mapper.tlb"  no_namespace raw_interfaces_only

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

extern "C" void tinchar(unsigned);


/////////////////////////////////////////////////////////////////////////////
// CTelnetDoc

IMPLEMENT_DYNCREATE(CTelnetDoc, CDocument)

BEGIN_MESSAGE_MAP(CTelnetDoc, CDocument)
	//{{AFX_MSG_MAP(CTelnetDoc)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_CONNECT, OnFileConnect)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CTelnetDoc, CDocument)
	//{{AFX_DISPATCH_MAP(CTelnetDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//      DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTelnetDoc construction/destruction

CTelnetDoc::CTelnetDoc()
{
	// TODO: add one-time construction code here
 /*
	EnableAutomation();

	AfxOleLockApp();
*/

	sessionid=1;
}

CTelnetDoc::~CTelnetDoc()
{
//	AfxOleUnlockApp();
}

BOOL CTelnetDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;
																		  
	((CTelnetApp*)AfxGetApp())->AddDocToList(this);
	return TRUE;
}

void CTelnetDoc::OnCloseDocument() 
{
	CDocument::OnCloseDocument();
	((CTelnetApp*)AfxGetApp())->RemDocFromList(this);
}


/////////////////////////////////////////////////////////////////////////////
// CTelnetDoc serialization

void CTelnetDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CTelnetDoc diagnostics

#ifdef _DEBUG
void CTelnetDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CTelnetDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTelnetDoc commands

void CTelnetDoc::OnFileOpen()
{

}

void CTelnetDoc::OnFileConnect() 
{
	CConnectDialog cdConn;
	char *p;
	char buf[200];

	if(cdConn.DoModal() != IDOK)
		return;

	sprintf(buf, "\r#ses ses%d %s %s\r", sessionid++, cdConn.m_Address, cdConn.m_Port);

	p = buf;

	while(*p)
		safe_tinchar(*p++);

}


// A class member to display characters on the screen

void CTelnetDoc::ShowStr(char *str)
{
	POSITION pos;
	CTelnetView *pv;
	int linestoscroll = 0;
	int charstoinval = 0;

	// first calc chars to invalidate, skipping ansi crap

	CEnhString cs = str;
	cs.StripAnsi();
	char *pc = cs.GetBuffer(1);

	while(*pc)
	{
		if(*pc == 0x0a)
			charstoinval = 0;
		else
			charstoinval++;

		*pc++;
	}

	pc = str;
	
	while(*pc)
	{  
	    if(*pc == 0x0a)
	    {
		    ScreenBuffer.InsertChar(0x0d);
		    linestoscroll++;
	    }

	    if(*pc != 0x0d)
		    ScreenBuffer.InsertChar(*pc);

	    if(*pc == 0x08)		// Backspace
	    {
		    pos = GetFirstViewPosition();

		    while(pos != NULL)
		    {
			pv = (CTelnetView*)GetNextView(pos);
			    pv->InvalidateNextChar();
		    }
	    }

	    pc++;
		    
	}

	pos = GetFirstViewPosition();

	while(pos != NULL)
	{
	    pv = (CTelnetView*)GetNextView(pos);

		if(linestoscroll)
		{
			// Scroll if we are at the end of the buffer and cursor is as well
	
			if(ScreenBuffer.GetInsertLine() == (ScreenBuffer.Range()-1))
					pv->ScrollUp(linestoscroll);
			else
				pv->SetSize();        		// need to resize anyway

       		pv->UpdateWindow();
		}

		// invalidate chars on last row

		pv->InvalidateLastChar(/*charstoinval*/999);
    }
}

// A class member to replace a line

void CTelnetDoc::RepLine(char *str)
{
	ScreenBuffer.ReplaceCurrent(str);
}


// A class member to set the current insert position

int CTelnetDoc::SetInsertPos(int type, int pos)
{
	POSITION pn;
	CTelnetView *pv;

	int rc = ScreenBuffer.SetInsertPos(type, pos);

	pn = GetFirstViewPosition();

	while(pn != NULL)
	{
	  pv = (CTelnetView*)GetNextView(pn);
		pv->SetCaret();
	}

	return rc;
}


// A C function to display characters on the screen

extern "C" int showstr(char *str, int handle)
{
//	TRACE("Starting showstr\n");

	// find the main window, and through it the current document

	CTelnetDoc* cDoc = ((CTelnetApp*)AfxGetApp())->GetDocument(handle);

	if(cDoc != NULL)
	{
		cDoc->ShowStr(str);
		return 1;
	}
	
	return 0;		
}

// A C function to replace the line on the screen

extern "C" int repline(char *str, int handle)
{
	// find the main window, and through it the current document

	CTelnetDoc* cDoc = ((CTelnetApp*)AfxGetApp())->GetDocument(handle);

	if(cDoc != NULL)
	{
		cDoc->RepLine(str);
		return 1;
	}
	
	return 0;		
}

// A C function to set the current insert position

extern "C" setinsertpos(int type, int pos, int handle)
{
	// find the main window, and through it the current document

	CTelnetDoc* cDoc = ((CTelnetApp*)AfxGetApp())->GetDocument(handle);

	if(cDoc != NULL)
		return cDoc->SetInsertPos(type, pos);
	
	return 0;		
}

// A C function to open a new window and return its 'handle'

extern "C" int newwindow(char *title)
{
	return ((CTelnetApp*)AfxGetApp())->NewDocument(title);	
}

// A C function to return the main window handle

extern "C" HWND getmainwnd()
{
	return AfxGetMainWnd()->m_hWnd;
}

// A C function to quit the application

extern "C" void closemainwindow()
{
	AfxGetMainWnd()->SendMessage(WM_CLOSE);	
}

// A C function to return the main window handle

extern "C" HWND mainwnd()
{
	return AfxGetMainWnd()->m_hWnd;
}

// A C function to set the window which should posess the caret

extern "C" void setcarethandle(int iHandle)
{
	((CTelnetApp*)AfxGetApp())->iCaretHandle = iHandle;
}

// A C function to return a text explanation given a Winsock error number

extern "C" void winsockerrmsg(int nError, LPSTR pszError)
{
  wsprintf(pszError, "WinSock error %d: ", nError);

  switch (nError)
  {
    case WSAEINTR:
      lstrcat(pszError, "Interrupted system call");
      break;
    case WSAEBADF:
      lstrcat(pszError, "Bad file number");
      break;
    case WSAEACCES:
      lstrcat(pszError, "Permission denied");
      break;
    case WSAEFAULT:
      lstrcat(pszError, "Bad address");
      break;
    case WSAEINVAL:
      lstrcat(pszError, "Invalid argument");
      break;
    case WSAEMFILE:
      lstrcat(pszError, "Too many open files");
      break;
    case WSAEWOULDBLOCK:
      lstrcat(pszError, "Operation would block");
      break;
    case WSAEINPROGRESS:
      lstrcat(pszError, "Operation now in progress");
      break;
    case WSAEALREADY:
      lstrcat(pszError, "Operation already in progress");
      break;
    case WSAENOTSOCK:
      lstrcat(pszError, "Socket operation on non-socket");
      break;
    case WSAEDESTADDRREQ:
      lstrcat(pszError, "Destination address required");
      break;
    case WSAEMSGSIZE:
      lstrcat(pszError, "Message too long");
      break;
    case WSAEPROTOTYPE:
      lstrcat(pszError, "Protocol wrong type for socket");
      break;
    case WSAENOPROTOOPT:
      lstrcat(pszError, "Protocol not available");
      break;
    case WSAEPROTONOSUPPORT:
      lstrcat(pszError, "Protocol not supported");
      break;
    case WSAESOCKTNOSUPPORT:
      lstrcat(pszError, "Socket type not supported");
      break;
    case WSAEOPNOTSUPP:
      lstrcat(pszError, "Operation not supported on socket");
      break;
    case WSAEPFNOSUPPORT:
      lstrcat(pszError, "Protocol family not supported");
      break;
    case WSAEAFNOSUPPORT:
      lstrcat(pszError, "Address family not supported by protocol family");
      break;
    case WSAEADDRINUSE:
      lstrcat(pszError, "Address already in use");
      break;
    case WSAEADDRNOTAVAIL:
      lstrcat(pszError, "Can't assign requested address");
      break;
    case WSAENETDOWN:
      lstrcat(pszError, "Network is down");
      break;
    case WSAENETUNREACH:
      lstrcat(pszError, "Network is unreachable");
      break;
    case WSAENETRESET:
      lstrcat(pszError, "Network dropped connection on reset");
      break;
    case WSAECONNABORTED:
      lstrcat(pszError, "Software caused connection abort");
      break;
    case WSAECONNRESET:
      lstrcat(pszError, "Connection reset by peer");
      break;
    case WSAENOBUFS:
      lstrcat(pszError, "No buffer space available");
      break;
    case WSAEISCONN:
      lstrcat(pszError, "Socket is already connected");
      break;
    case WSAENOTCONN:
      lstrcat(pszError, "Socket is not connected");
      break;
    case WSAESHUTDOWN:
      lstrcat(pszError, "Can't send after socket shutdown");
      break;
    case WSAETOOMANYREFS:
      lstrcat(pszError, "Too many references: can't splice");
      break;
    case WSAETIMEDOUT:
      lstrcat(pszError, "Connection timed out");
      break;
    case WSAECONNREFUSED:
      lstrcat(pszError, "Connection refused");
      break;
    case WSAELOOP:
      lstrcat(pszError, "Too many levels of symbolic links");
      break;
    case WSAENAMETOOLONG:
      lstrcat(pszError, "File name too long");
      break;
    case WSAEHOSTDOWN:
      lstrcat(pszError, "Host is down");
      break;
    case WSAEHOSTUNREACH:
      lstrcat(pszError, "No route to host");
      break;
    case WSAENOTEMPTY:
      lstrcat(pszError, "Directory not empty");
      break;
    case WSAEPROCLIM:
      lstrcat(pszError, "Too many processes");
      break;
    case WSAEUSERS:
      lstrcat(pszError, "Too many users");
      break;
    case WSAEDQUOT:
      lstrcat(pszError, "Disc quota exceeded");
      break;
    case WSAESTALE:
      lstrcat(pszError, "Stale NFS file handle");
      break;
    case WSAEREMOTE:
      lstrcat(pszError, "Too many levels of remote in path");
      break;
#ifdef _WIN32
    case WSAEDISCON:
      lstrcat(pszError, "Disconnect");
      break;
#endif
    case WSASYSNOTREADY:
      lstrcat(pszError, "Network sub-system is unusable");
      break;
    case WSAVERNOTSUPPORTED:
      lstrcat(pszError, "WinSock DLL cannot support this application");
      break;
    case WSANOTINITIALISED:
      lstrcat(pszError, "WinSock not initialized");
      break;
    case WSAHOST_NOT_FOUND:
      lstrcat(pszError, "Host not found");
      break;
    case WSATRY_AGAIN:
      lstrcat(pszError, "Non-authoritative host not found");
      break;
    case WSANO_RECOVERY:
      lstrcat(pszError, "Non-recoverable error");
      break;
    case WSANO_DATA:
      lstrcat(pszError, "Valid name, no data record of requested type");
      break;
    default:
      lstrcpy(pszError, "Not a WinSock error");
      break;
  }

  lstrcat(pszError, "\n");
}

// A C Function to display a message box

extern "C" void messagebox(LPSTR pszMessage)
{
  	AfxMessageBox(pszMessage);
} 

// A C function for tracing

extern "C" void ctrace(char *str)
{
	TRACE("*");
	TRACE(str);
	TRACE("\n");
}

// A C function to put text into a panel

extern "C" void paneltext(int ind, char *str)
{
	CMainFrame* mf = (CMainFrame*) AfxGetApp()->m_pMainWnd;

	mf->paneltext(ind, str);
}

// C interface to mapper com functions

int mapper_initialised = 0;
//int wininput_initialised = 0;


//_Script* s = NULL;

_Script m_Script;
CWinSink *cw;

extern "C" int winmapper(char *str)
{
	if(!mapper_initialised)
	{
		if(m_Script.CreateDispatch("Mapper.Script"))
		{
			mapper_initialised = 1;

			cw = new CWinSink();
			LPUNKNOWN pUnkSink = cw->GetIDispatch(FALSE);
			unsigned long dwCookie;
			AfxConnectionAdvise(m_Script.m_lpDispatch, IID_IWinSink, pUnkSink, FALSE, &dwCookie);

			m_Script.StartMain();
		}
	}

	if(mapper_initialised)
	{
		m_Script.MapCommand(str);
		return 1;
	}

	return 0;
}




CRITICAL_SECTION cs;
int cs_inited;

extern "C" void safe_tinchar(unsigned u)
{
	if(!cs_inited)
	{
		InitializeCriticalSection(&cs);
		cs_inited = 1;
	}

	EnterCriticalSection(&cs);

	tinchar(u);

	LeaveCriticalSection(&cs);
}


